#ifndef BASEPANEL_H
#define BASEPABEL_H

#include <QThread>
#include <QTextBrowser>
#include <QMainWindow>
#include <QDebug>

#include "ui_basepanel.h"

class ThreadSlot : public QThread
{
public:
    ThreadSlot()
    {
	objCount = 0;
	QThread::start();
	qDebug() << "THREADSLOT threadid: " << QThread::currentThreadId();
    }
    void removed()
    {
	objCount--;
	quit();
    }
    void moved()
    {
	objCount++;
    }
    void run()
    {
//	disp = eventDispatched();
	exec();
    }
private:
    int objCount;
};

class ObjectRunning : public QObject
{
Q_OBJECT
    public:
    ObjectRunning(QObject *parent, ThreadSlot *_in): QObject(parent)
    {
	in = _in;
	in->moved();
	moveToThread(in);
	QObject::connect(this, SIGNAL(signalMe(int)), this, SLOT(react(int)));
	qDebug() << "OBJECTRUNNING currentThreadId: " << QThread::currentThreadId();
    }
    ~ObjectRunning() {}
signals:
    void signalMe(int num);
public slots:
    void react(int num)
    {
    }
private:
    ThreadSlot *in;
};

class BasePanel : public QMainWindow
{
Q_OBJECT
public:
    BasePanel(QWidget *parent=NULL, Qt::WindowFlags flags=0);
    ~BasePanel();

signals:
    void doSomething();

private slots:
    void on_test_clicked()
    {
	switch(cnt)
	{
	    case 0:
		ui.log->append("-- CREATING THREADSLOT  --");
		signalThread = new ThreadSlot();
		signalThread->start();
		break;
	    default:
		ui.log->append("-- ADDING NEW OBJECT --");
		{
		    new ObjectRunning(NULL, signalThread);
		}
		break;
    	}
	++cnt;
    }

private:
    ThreadSlot *signalThread;
    Ui::BasePanel ui;
    int cnt;
};


#endif