include(block.pri)
QT += core gui widgets 

TEMPLATE=app
TARGET=output/block_test
CONFIG+= release warn_off
CONFIG-= tooltip app_bundle

QMAKE_CXXFLAGS_WARN_ON += -Wno-unused-parameter 

#Limit memory usage, so it could start on machines with 2GB RAM
QMAKE_WASM_TOTAL_MEMORY=512MB

contains(QT_CONFIG, c++11): CONFIG+= c++11

DEPENDPATH += .
INCLUDEPATH += . 

linux {
    MOC_DIR= ../.build/.moc
    OBJECTS_DIR= ../.build/.objs
    RCC_DIR= ../.build/.rcc
    UI_DIR= ../.build/.uic
    DESTDIR=.
}

emscripten {
    DEFINES+=WASM WEBASSEMBLY
    MOC_DIR= ../.build_wasm/.moc
    OBJECTS_DIR= ../.build_wasm/.objs
    RCC_DIR= ../.build_wasm/.rcc
    UI_DIR= ../.build_wasm/.uic
    DESTDIR=.
    INCLUDEPATH+=/usr/local/QT5WASM/include

    QMAKE_CXXFLAGS += -s ASSERTIONS=1 -g2 -std=c++11 -s USE_PTHREADS=1 -s WASM_MEM_MAX=3GB -s ALLOW_MEMORY_GROWTH=1 -s PTHREAD_POOL_SIZE=4
    QMAKE_LFLAGS += -g2 -std=c++11 -s USE_PTHREADS=1 -s WASM_MEM_MAX=3GB -s ALLOW_MEMORY_GROWTH=1 -s PTHREAD_POOL_SIZE=4 -l idbfs.js

}





